"""capability default casa capo key

Revision ID: eaca2da45ab6
Revises: 15d7b52aace4
Create Date: 2024-06-11 22:33:12.112244

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'eaca2da45ab6'
down_revision = '15d7b52aace4'
branch_labels = None
depends_on = None

NEW_COLUMN_NAME = "default_casa_capo_key"

# Separating on a pipe to distinguish vla|alma values, this could probably be a JSON column
DEFAULT_CASA_CAPO_KEYS = {
    "std_calibration": "homeForReprocessing",
    "restore_cms": "homeForVlaRestore|homeForAlmaRestore",
    "restore_basic_ms": "homeForDownloads",
    "std_cms_imaging": "homeForReprocessing",
    "std_restore_imaging": "homeForReprocessing",
}


def upgrade():
    op.add_column(
        "capabilities",
        sa.Column(
            NEW_COLUMN_NAME,
            sa.String,
            comment="CAPO key pointing to the default CASA version for each capability",
        ),
    )

    for k, v in DEFAULT_CASA_CAPO_KEYS.items():
        op.execute(
            f"""
            UPDATE capabilities
            SET {NEW_COLUMN_NAME} = '{v}'
            WHERE capability_name = '{k}'
            """
        )


def downgrade():
    op.drop_column("capabilities", NEW_COLUMN_NAME)
